#!/bin/sh
config() {
  NEW="$1"
  OLD="`dirname $NEW`/`basename $NEW .new`"
  # If there's no config file by that name, mv it over:
  if [ ! -r $OLD ]; then
    mv $NEW $OLD
  elif [ "`cat $OLD | md5sum`" = "`cat $NEW | md5sum`" ]; then # toss the redundant copy
    rm $NEW
  fi
  # Otherwise, we leave the .new copy for the admin to consider...
}

# Keep same perms on rc.bind.new:
if [ -e etc/rc.d/rc.bind ]; then
  cp -a etc/rc.d/rc.bind etc/rc.d/rc.bind.new.incoming
  cat etc/rc.d/rc.bind.new > etc/rc.d/rc.bind.new.incoming
  mv etc/rc.d/rc.bind.new.incoming etc/rc.d/rc.bind.new
fi

config etc/named.conf.new
config etc/rc.d/rc.bind.new

# Add a /var/named if it doesn't exist:
if [ ! -d var/named ]; then
  mkdir -p var/named
  chmod 755 var/named
fi

# Generate /etc/rndc.key if there's none there,
# and there also no /etc/rndc.conf (the other
# way to set this up).
if [ ! -r etc/rndc.key -a ! -r /etc/rndc.conf ]; then
  chroot . /sbin/ldconfig
  chroot . /usr/sbin/rndc-confgen -r /dev/urandom -a 2> /dev/null
fi
( cd usr/lib64 ; rm -rf libbind9.so )
( cd usr/lib64 ; ln -sf libbind9.so.1201.0.0 libbind9.so )
( cd usr/lib64 ; rm -rf libbind9.so.1201 )
( cd usr/lib64 ; ln -sf libbind9.so.1201.0.0 libbind9.so.1201 )
( cd usr/lib64 ; rm -rf libdns.so )
( cd usr/lib64 ; ln -sf libdns.so.1207.0.1 libdns.so )
( cd usr/lib64 ; rm -rf libdns.so.1207 )
( cd usr/lib64 ; ln -sf libdns.so.1207.0.1 libdns.so.1207 )
( cd usr/lib64 ; rm -rf libirs.so )
( cd usr/lib64 ; ln -sf libirs.so.1201.0.0 libirs.so )
( cd usr/lib64 ; rm -rf libirs.so.1201 )
( cd usr/lib64 ; ln -sf libirs.so.1201.0.0 libirs.so.1201 )
( cd usr/lib64 ; rm -rf libisc.so )
( cd usr/lib64 ; ln -sf libisc.so.1204.0.0 libisc.so )
( cd usr/lib64 ; rm -rf libisc.so.1204 )
( cd usr/lib64 ; ln -sf libisc.so.1204.0.0 libisc.so.1204 )
( cd usr/lib64 ; rm -rf libisccc.so )
( cd usr/lib64 ; ln -sf libisccc.so.1201.0.0 libisccc.so )
( cd usr/lib64 ; rm -rf libisccc.so.1201 )
( cd usr/lib64 ; ln -sf libisccc.so.1201.0.0 libisccc.so.1201 )
( cd usr/lib64 ; rm -rf libisccfg.so )
( cd usr/lib64 ; ln -sf libisccfg.so.1203.0.0 libisccfg.so )
( cd usr/lib64 ; rm -rf libisccfg.so.1203 )
( cd usr/lib64 ; ln -sf libisccfg.so.1203.0.0 libisccfg.so.1203 )
( cd usr/lib64 ; rm -rf libns.so )
( cd usr/lib64 ; ln -sf libns.so.1205.0.0 libns.so )
( cd usr/lib64 ; rm -rf libns.so.1205 )
( cd usr/lib64 ; ln -sf libns.so.1205.0.0 libns.so.1205 )
( cd usr/man/man1 ; rm -rf bind9-config.1.gz )
( cd usr/man/man1 ; ln -sf isc-config.sh.1.gz bind9-config.1.gz )
( cd usr/man/man8 ; rm -rf named-compilezone.8.gz )
( cd usr/man/man8 ; ln -sf named-checkzone.8.gz named-compilezone.8.gz )
( cd usr/man/man8 ; rm -rf tsig-keygen.8.gz )
( cd usr/man/man8 ; ln -sf ddns-confgen.8.gz tsig-keygen.8.gz )
( cd usr/sbin ; rm -rf lwresd )
( cd usr/sbin ; ln -sf named lwresd )
( cd usr/sbin ; rm -rf named-compilezone )
( cd usr/sbin ; ln -sf named-checkzone named-compilezone )
( cd usr/sbin ; rm -rf tsig-keygen )
( cd usr/sbin ; ln -sf ddns-confgen tsig-keygen )
